/**
 * The SharedHistory class contains the kobold's shared, structured history of 
 * interactions with important characters.
 */
function SharedHistory() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.caravanBandits = new CaravanBandits();
    this.tenPawGang = new TenPawGang();
    this.debtCollector = new DebtCollector();
    this.dragonessPrincess = new DragonessPrincess();
    this.home = new HomeStatus();
    this.seki = new Seki();
    this.cassidy = new Cassidy();
    this.farmerhouse = new FarmerHouseShared();
    this.varanar = new VaranarShared();
    this.enslavement = new EnslavementShared();
    this.well = new HamletWellShared();

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this object from a type-stripped version thereof.
     * @param {SharedHistory-stripped} sharedHistory A SharedHistory object, stripped of private members and all functions.
     */
    this.load = function (sharedHistory) {
        if (!sharedHistory) {
            that.load(new SharedHistory());
            return;
        }
        that.caravanBandits.load(sharedHistory.caravanBandits);
        that.tenPawGang.load(sharedHistory.tenPawGang);
        that.debtCollector.load(sharedHistory.debtCollector);
        that.dragonessPrincess.load(sharedHistory.dragonessPrincess);
        that.home.load(sharedHistory.home);
        that.seki.load(sharedHistory.seki);
        that.cassidy.load(sharedHistory.cassidy);
        that.farmerhouse.load(sharedHistory.farmerhouse);
        that.varanar.load(sharedHistory.varanar);
        that.enslavement.load(sharedHistory.enslavement);
        that.well.load(sharedHistory.well);
    };
}
