/**
 * What the kobold did during the first night of enslavement.
 */
function EnslavementNightOneShared() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.nameStated = false; // Whether or not the kobold stated its name.
    this.knockedOut = false; // Whether or not the kobold was knocked out.
    this.escapedBindings = false; // Whether or not the kobold was knocked out.
    this.complianceRating = 0; // Compliance rating for night one. A number between one and ten signifying how well the kobold behaved.

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this object from a type-stripped version thereof.
     * @param {EnslavementNightOneShared-stripped} nightOne A EnslavementNightOneShared object, stripped of private members and all functions.
     */
    this.load = function (nightOne) {
        if (!nightOne) {
            that.load(new EnslavementNightOneShared());
            return;
        }
        that.nameStated = nightOne.nameStated || false;
        that.knockedOut = nightOne.knockedOut || false;
        that.escapedBindings = nightOne.escapedBindings || false;
        that.complianceRating = nightOne.complianceRating || 0;
    };
}

