/**
 * A generic menu button, containing functionality used by all of them.
 */
function GenericMenuButton() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var selectedClass = "menubuttonselected";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /*
     * Opens a url in a new tab.
     * @param {string} url The url to open. May be relative if it starts with a slash.
     */
    this.open = function (url) {
        var win = window.open(url, '_blank');
        win.focus();
    };

    /**
     * Unsets the button with the given id.
     * @param {string} id The id of the button.
     */
    this.unset = function (id) {
        $("#" + id).removeClass(selectedClass);
        global.ui.menu.resetSubtitle();
        global.ui.menu.resetContent();
    };

    /**
     * Sets the button with the given id.
     * @param {string} id The id of the button.
     * @param {string} subtitle Subtitle to set.
     * @param {string} content Content to set.
     */
    this.set = function (id, subtitle, content) {
        global.ui.menu.buttons.unset();
        $("#" + id).addClass(selectedClass);
        global.ui.menu.setSubtitle(subtitle);
        global.ui.menu.setContent(content);
    };
}
