/**
 * Controller for the Underground Cave scene.
 * @param {string} sceneId The id of the scene.
 */
function UndergroundCaveController(sceneId) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var id = sceneId;
    SceneController.call(this, id);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.nextSceneReady = true;
    this.nextSceneName = "NightTwo";
    this.nextFolderName = "Varanar";

    this.misc = new MiscController(id, "misc");

    this.arrival = new ChangeController(id, "arrival", function () {
        global.kobold.status.physical.decrease(10, "Drowning");
        global.kobold.status.mental.decrease(9, "Near-death experience");
        global.kobold.status.stamina.decrease(10, "Drowning");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Drowning", "Health", -10),
            new Change("Near-death experience", "Sanity", -10),
            new Change("Still alive", "Sanity", +1),
            new Change("Underwater crawling", "Stamina", -5),
            new Change("Drowning", "Stamina", -5)
        ]);
    });

    // Actually a reset controller.
    this.surface = new UndoController(id, "surface", function change() {
        var healthBacklog = new ChoiceController(id, "surfaceHealthBacklog");
        var sanityBacklog = new ChoiceController(id, "surfaceSanityBacklog");
        var staminaBacklog = new ChoiceController(id, "surfaceStaminaBacklog");
        var exertionBacklog = new ChoiceController(id, "surfaceExertionBacklog");
        var healthLHBacklog = new ChoiceController(id, "surfaceLHHealthBacklog");
        var sanityLHBacklog = new ChoiceController(id, "surfaceLHSanityBacklog");
        var staminaLHBacklog = new ChoiceController(id, "surfaceLHStaminaBacklog");
        var exertionLHBacklog = new ChoiceController(id, "surfaceLHExertionBacklog");
        healthBacklog.set(global.kobold.status.physical.get());
        sanityBacklog.set(global.kobold.status.mental.get());
        staminaBacklog.set(global.kobold.status.stamina.get());
        exertionBacklog.set(global.kobold.status.exertion.get());
        healthLHBacklog.set(global.kobold.status.physical.lasthit);
        sanityLHBacklog.set(global.kobold.status.mental.lasthit);
        staminaLHBacklog.set(global.kobold.status.stamina.lasthit);
        exertionLHBacklog.set(global.kobold.status.exertion.lasthit);
    }, function changeNote() {
        return "";
    }, function undoChange() {
        var healthBacklog = new ChoiceController(id, "surfaceHealthBacklog");
        var sanityBacklog = new ChoiceController(id, "surfaceSanityBacklog");
        var staminaBacklog = new ChoiceController(id, "surfaceStaminaBacklog");
        var exertionBacklog = new ChoiceController(id, "surfaceExertionBacklog");
        var healthLHBacklog = new ChoiceController(id, "surfaceLHHealthBacklog");
        var sanityLHBacklog = new ChoiceController(id, "surfaceLHSanityBacklog");
        var staminaLHBacklog = new ChoiceController(id, "surfaceLHStaminaBacklog");
        var exertionLHBacklog = new ChoiceController(id, "surfaceLHExertionBacklog");
        global.kobold.status.physical.set(healthBacklog.get());
        global.kobold.status.physical.lasthit = healthLHBacklog.get();
        global.kobold.status.mental.set(sanityBacklog.get());
        global.kobold.status.mental.lasthit = sanityLHBacklog.get();
        global.kobold.status.stamina.set(staminaBacklog.get());
        global.kobold.status.stamina.lasthit = staminaLHBacklog.get();
        global.kobold.status.exertion.set(exertionBacklog.get());
        global.kobold.status.exertion.lasthit = exertionLHBacklog.get();
        global.kobold.history.shared.well.basiliskMet = false;
        global.kobold.history.shared.well.basiliskFought = false;
        global.kobold.history.shared.well.basiliskKilled = false;
        global.kobold.history.shared.well.basiliskFriend = false;
        global.kobold.history.shared.well.basiliskPetrified = false;
        global.kobold.history.shared.well.basiliskFucked = false;
        global.kobold.history.shared.well.basiliskPenetrated = false;
        global.kobold.history.shared.well.basiliskEnjoyed = false;
        global.kobold.history.shared.well.basiliskFingerDislocated = false;
        global.kobold.history.shared.well.basiliskDominated = false;
        global.kobold.history.shared.well.basiliskPeed = false;
        global.kobold.history.shared.well.basiliskOral = false;
        global.kobold.history.shared.well.basiliskDomFucked = false;
    });

    this.run = new ChangeController(id, "run", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.decrease(7, "Swimming while exerted");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Swimming", "Stamina", -10),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.stare = new UndoController(id, "stare", function () {
        global.kobold.status.mental.decrease(10, "Being petrified");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Petrification", "Sanity", -6),
            new Change("Panic", "Sanity", -4)
        ]);
    });

    this.relent = new ChoiceController(id, "relent");

    this.enjoy = new ChangeController(id, "enjoy", function () {
        var dick = that.misc.dick();
        var pants = that.misc.pants();
        var underwear = that.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        if (dick) {
            if (clothingMale) {
                that.misc.shirt() && global.kobold.inventory.equipment.shirt.stain("Basilisk Cum");
                global.kobold.status.mental.decrease(3, "Thighfucked by basilisk");
                global.kobold.status.exertion.increase(8, "Thighfucked by basilisk");
            } else {
                global.kobold.body.analVirgin = false;
                global.kobold.status.mental.increase(4, "Basilisk buttsex");
                global.kobold.status.exertion.increase(20, "Basilisk buttsex");
            }
        } else {
            if (clothingFemale) {
                that.misc.shirt() && global.kobold.inventory.equipment.shirt.stain("Basilisk Cum");
                global.kobold.status.mental.decrease(3, "Thighfucked by basilisk");
                global.kobold.status.exertion.increase(8, "Thighfucked by basilisk");
            } else {
                global.kobold.body.vaginalVirgin = false;
                global.kobold.status.mental.increase(10, "Basilisk sex");
                global.kobold.status.exertion.increase(25, "Basilisk sex");
            }
        }
    }, function () {
        var dick = that.misc.dick();
        var pants = that.misc.pants();
        var underwear = that.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        if (dick) {
            if (clothingMale) {
                return global.ui.change.buildNotification([
                    new Change("Excitement", "Sanity", +2),
                    new Change("Pleasure denied", "Sanity", -5),
                    new Change("Petrified-thigh-fucked", "Sexual exhaustion", +8, true)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("Excitement", "Sanity", +2),
                    new Change("Thoroughly rutted", "Sanity", +7),
                    new Change("Pleasure denied", "Sanity", -5),
                    new Change("Ferally buttfucked", "Sexual exhaustion", +20, true)
                ]);
            }
        } else {
            if (clothingFemale) {
                return global.ui.change.buildNotification([
                    new Change("Excitement", "Sanity", +2),
                    new Change("Pleasure denied", "Sanity", -5),
                    new Change("Petrified-thigh-fucked", "Sexual exhaustion", +8, true)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("Excitement", "Sanity", +2),
                    new Change("Thoroughly rutted", "Sanity", +5),
                    new Change("Reached climax", "Sanity", +5),
                    new Change("Only one orgasm", "Sanity", -2),
                    new Change("Bestially bred", "Sexual exhaustion", +20, true),
                    new Change("Reached orgasm", "Sexual exhaustion", +5, true)
                ]);
            }
        }
    });

    this.hate = new ChangeController(id, "hate", function () {
        var dick = that.misc.dick();
        var pants = that.misc.pants();
        var underwear = that.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        if (dick) {
            if (clothingMale) {
                that.misc.shirt() && global.kobold.inventory.equipment.shirt.stain("Basilisk Cum");
                global.kobold.status.mental.decrease(12, "Thighfucked by basilisk");
                global.kobold.status.exertion.increase(8, "Thighfucked by basilisk");
            } else {
                global.kobold.body.analVirgin = false;
                global.kobold.status.physical.decrease(5, "Raped by basilisk");
                global.kobold.status.mental.decrease(20, "Raped by basilisk");
                global.kobold.status.exertion.increase(25, "Raped by basilisk");
            }
        } else {
            if (clothingFemale) {
                that.misc.shirt() && global.kobold.inventory.equipment.shirt.stain("Basilisk Cum");
                global.kobold.status.mental.decrease(12, "Thighfucked by basilisk");
                global.kobold.status.exertion.increase(8, "Thighfucked by basilisk");
            } else {
                global.kobold.body.vaginalVirgin = false;
                global.kobold.status.physical.decrease(5, "Raped by basilisk");
                global.kobold.status.mental.decrease(20, "Raped by basilisk");
                global.kobold.status.exertion.increase(25, "Raped by basilisk");
            }
        }
    }, function () {
        var dick = that.misc.dick();
        var pants = that.misc.pants();
        var underwear = that.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        if (dick) {
            if (clothingMale) {
                return global.ui.change.buildNotification([
                    new Change("Defiled", "Sanity", -8),
                    new Change("Thigh-fucked by a feral", "Sanity", -8),
                    new Change("Didn't get penetrated", "Sanity", +4),
                    new Change("Petrified-thigh-raped", "Sexual exhaustion", +8, true)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("Painful insertion", "Health", -5),
                    new Change("Defiled", "Sanity", -8),
                    new Change("Raped by a beast", "Sanity", -12),
                    new Change("Ferally buttfucked", "Sexual exhaustion", +20, true),
                    new Change("Raped", "Sexual exhaustion", +5, true)
                ]);
            }
        } else {
            if (clothingFemale) {
                return global.ui.change.buildNotification([
                    new Change("Defiled", "Sanity", -8),
                    new Change("Thigh-fucked by a feral", "Sanity", -8),
                    new Change("Didn't get penetrated", "Sanity", +4),
                    new Change("Petrified-thigh-raped", "Sexual exhaustion", +8, true)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("Painful insertion", "Health", -5),
                    new Change("Defiled", "Sanity", -8),
                    new Change("Raped by a beast", "Sanity", -12),
                    new Change("Ferally bred", "Sexual exhaustion", +20, true),
                    new Change("Raped", "Sexual exhaustion", +5, true)
                ]);
            }
        }
    });

    function regainRelentChange() {
        var dick = that.misc.dick();
        var pants = that.misc.pants();
        var underwear = that.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;

        global.kobold.status.stamina.increase(3, "Minor reprieve");
        global.kobold.stats.decreaseStat(StatsEnum.AGILITY, 1);
        global.kobold.stats.increaseStat(StatsEnum.ENDURANCE, 1);

        if (dick) {
            if (clothingMale) {
                global.kobold.status.mental.decrease(3, "Sexual frustration");
                global.kobold.status.exertion.increase(2, "Sexual frustration");
            } else {
                global.kobold.status.mental.increase(1, "Escaped the cave");
                global.kobold.status.exertion.increase(2, "Sexual frustration");
            }
        } else {
            if (clothingFemale) {
                global.kobold.status.mental.decrease(3, "Sexual frustration");
                global.kobold.status.exertion.increase(2, "Sexual frustration");
            } else {
                global.kobold.status.mental.increase(1, "Escaped the cave");
            }
        }
    }

    function regainRelentNote() {
        var dick = that.misc.dick();
        var pants = that.misc.pants();
        var underwear = that.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        if (dick) {
            if (clothingMale) {
                return global.ui.change.buildNotification([
                    new Change("Sexual frustration", "Sanity", -6),
                    new Change("Escaped the cave", "Sanity", +3),
                    new Change("Minor reprieve", "Stamina", +3),
                    new Change("Sexual frustration", "Sexual exhaustion", +2, true),
                    new Change("Petrification after effects", "Agility", -1),
                    new Change("Petrification after effects", "Endurance", +1)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("Sexual frustration", "Sanity", -2),
                    new Change("Escaped the cave", "Sanity", +3),
                    new Change("Minor reprieve", "Stamina", +3),
                    new Change("Sexual frustration", "Sexual exhaustion", +2, true),
                    new Change("Petrification after effects", "Agility", -1),
                    new Change("Petrification after effects", "Endurance", +1)
                ]);
            }
        } else {
            if (clothingFemale) {
                return global.ui.change.buildNotification([
                    new Change("Sexual frustration", "Sanity", -6),
                    new Change("Escaped the cave", "Sanity", +3),
                    new Change("Minor reprieve", "Stamina", +3),
                    new Change("Sexual frustration", "Sexual exhaustion", +2, true),
                    new Change("Petrification after effects", "Agility", -1),
                    new Change("Petrification after effects", "Endurance", +1)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("Minor sexual frustration", "Sanity", -2),
                    new Change("Escaped the cave", "Sanity", +3),
                    new Change("Minor reprieve", "Stamina", +3),
                    new Change("Petrification after effects", "Agility", -1),
                    new Change("Petrification after effects", "Endurance", +1)
                ]);
            }
        }
    }

    function regainHateChange() {
        global.kobold.status.mental.decrease(1, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
        global.kobold.stats.decreaseStat(StatsEnum.AGILITY, 1);
        global.kobold.stats.increaseStat(StatsEnum.ENDURANCE, 1);
    }

    function regainHateNote() {
        return global.ui.change.buildNotification([
            new Change("Re-living rape", "Sanity", -2),
            new Change("Self-pity", "Sanity", -2),
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3),
            new Change("Petrification after effects", "Agility", -1),
            new Change("Petrification after effects", "Endurance", +1)
        ]);
    }

    this.regain = new ChangeController(id, "regain", function () {
        if (that.relent.get() === UndergroundCaveRelentChoice.ENJOY) {
            regainRelentChange();
        } else {
            regainHateChange();
        }
    }, function () {
        if (that.relent.get() === UndergroundCaveRelentChoice.ENJOY) {
            return regainRelentNote();
        } else {
            return regainHateNote();
        }
    });

    this.resistFail = new ChoiceController(id, "resistFail");

    this.resistSucceed = new UndoController(id, "resistSucceed", function () {
        global.kobold.status.mental.increase(5, "Resisted petrification");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Resisted petrification", "Sanity", +5)
        ]);
    });

    this.avert = new UndoController(id, "avert", function () {
        global.kobold.status.mental.decrease(5, "Panicking");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Panic", "Sanity", -5)
        ]);
    });

    this.nuzzle = new ChangeController(id, "nuzzle", function () {
        global.kobold.status.mental.increase(6, "Cautious optimism");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Cautious optimism", "Sanity", +6)
        ]);
    });

    this.lick = new ChangeController(id, "lick", function () {
        global.kobold.status.physical.increase(8, "Wound healed");
        global.kobold.status.mental.increase(8, "Cautious optimism");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Wound healed", "Health", +8),
            new Change("Pain fading", "Sanity", +2),
            new Change("Cautious optimism", "Sanity", +6)
        ]);
    });

    this.doggo = new ChoiceController(id, "doggo");

    this.pet = new ChoiceController(id, "pet");

    this.scratch = new ChangeController(id, "scratch", function () {
        global.kobold.status.mental.increase(9, "Intensive petting");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Pet the basilisk", "Sanity", +5),
            new Change("Made a friend", "Sanity", +4)
        ]);
    });

    this.throat = new ChangeController(id, "throat", function () {
        global.kobold.status.mental.decrease(5, "Killing the basilisk");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Killed a vicious creature?", "Sanity", +3),
            new Change("Murdered an animal", "Sanity", -4),
            new Change("Betrayed trust", "Sanity", -4)
        ]);
    });

    this.throatLoot = new ChangeController(id, "throatLoot", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
        global.kobold.inventory.bag.addMisc(new BasiliskScales());
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3),
            new Change("Trophies", global.kobold.inventory.createItemWithTooltip(new BasiliskScales(), true), +1)
        ]);
    });

    this.fetch = new ChangeController(id, "fetch", function () {
        that.misc.weapon();
        global.kobold.status.mental.increase(6, "Awkward game of fetch");
        global.kobold.inventory.equipment.strip(SlotEnum.WEAPON);
        global.kobold.inventory.equipment.wear(new PetrifiedBranch());
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Played fetch", "Sanity", +2),
            new Change("Made a friend", "Sanity", +4),
            new Change("Branch petrified", global.kobold.inventory.createItemWithTooltip(that.misc.weapon(), true), -1),
            new Change("New weapon", global.kobold.inventory.createItemWithTooltip(new PetrifiedBranch(), true), +1)
        ]);
    });

    this.feed = new ChangeController(id, "feed", function () {
        global.kobold.status.mental.increase(6, "Fed animal");
        global.kobold.inventory.bag.removeConsumable(new HeartyMeal());
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Fed animal", "Sanity", +2),
            new Change("Made a friend", "Sanity", +4),
            new Change("Lost a meal", global.kobold.inventory.createItemWithTooltip(new HeartyMeal(), true), -1)
        ]);
    });

    this.prePatch = new ChoiceController(id, "prePatch");

    this.basiPatch = new ChoiceController(id, "basiPatch");

    this.basiTake = new ChangeController(id, "basiTake", function () {
        global.kobold.inventory.equipment.wear(new Eyepatch());
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Took eyepatch", global.kobold.inventory.createItemWithTooltip(new Eyepatch(), true), +1)
        ]);
    });

    this.basiLeave = new ChangeController(id, "basiLeave", function () {
        global.kobold.status.mental.decrease(1, "Left friend behind");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Left behind the basilisk", "Sanity", -4),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.fight = new ChoiceController(id, "fight");

    this.defence = new ChangeController(id, "defence", function () {
        global.kobold.status.physical.decrease(10, "Fighting the basilisk");
        global.kobold.status.mental.increase(5, "Scared off basilisk");
        global.kobold.status.stamina.decrease(10, "Defensive combat");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Broke hand", "Health", -10),
            new Change("Broke hand", "Sanity", -5),
            new Change("Scared off the basilisk", "Sanity", +10),
            new Change("Defensive combat", "Stamina", -10)
        ]);
    });

    /*this.defencePatch = new ChoiceController(id, "defencePatch");
     
     this.defencePatchTake = new ChangeController(id, "defencePatchTake", function () {
     
     }, function () {
     return global.ui.change.buildNotification([
     new Change("TODO", "CHANGE", +1)
     ]);
     });*/

    this.defenceLeave = new ChangeController(id, "defenceLeave", function () {
        global.kobold.status.physical.increase(2, "Fixed hand");
        global.kobold.status.mental.decrease(3, "Escaping the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Fixed hand", "Health", +2),
            new Change("Intense pain", "Sanity", -6),
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.offenceWin = new ChangeController(id, "offenceWin", function () {
        global.kobold.status.mental.decrease(6, "Killing the basilisk");
        global.kobold.status.stamina.decrease(8, "Combat");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Killed a monster", "Sanity", +4),
            new Change("Became the monster?", "Sanity", -10),
            new Change("Combat", "Stamina", -8)
        ]);
    });

    this.offenceLoot = new ChangeController(id, "offenceLoot", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
        global.kobold.inventory.bag.addMisc(new BasiliskScales());
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3),
            new Change("Trophies", global.kobold.inventory.createItemWithTooltip(new BasiliskScales(), true), +1)
        ]);
    });

    this.wrestleWin = new UndoController(id, "wrestleWin", function () {
        global.kobold.status.physical.decrease(18, "Repeatedly crushed");
        global.kobold.status.mental.decrease(4, "Head crushed");
        global.kobold.status.stamina.decrease(15, "Intense struggle");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Repeatedly crushed", "Health", -18),
            new Change("Head crushed", "Sanity", -4),
            new Change("Intense struggle", "Stamina", -15)
        ]);
    });

    this.snap = new ChangeController(id, "snap", function () {
        global.kobold.status.mental.decrease(6, "Killing the basilisk");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Killed a monster", "Sanity", +4),
            new Change("Became the monster?", "Sanity", -10)
        ]);
    });

    this.snapLeave = new ChangeController(id, "snapLeave", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
        global.kobold.inventory.bag.addMisc(new BasiliskScales());
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3),
            new Change("Trophies", global.kobold.inventory.createItemWithTooltip(new BasiliskScales(), true), +1)
        ]);
    });

    this.letGo = new ChangeController(id, "letGo", function () {
        global.kobold.status.physical.increase(3, "Drinking water");
        global.kobold.status.mental.increase(8, "Sparing the basilisk");
        global.kobold.status.stamina.increase(3, "Drinking water");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Fresh water", "Health", +3),
            new Change("Spared a life", "Sanity", +8),
            new Change("Fresh water", "Stamina", +3)
        ]);
    });

    this.letGoLeave = new ChangeController(id, "letGoLeave", function () {
        global.kobold.status.mental.increase(3, "Escaping the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.dominance = new UndoController(id, "dominance", function () {
        // Unused.
    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.pee = new ChangeController(id, "pee", function () {
        global.kobold.status.mental.increase(6, "Peeing on a basilisk");
        global.kobold.status.stamina.increase(5, "Relaxing whizz");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Dominated foe", "Sanity", +10),
            new Change("Peeing on a feral", "Sanity", -4),
            new Change("Relaxing whizz", "Stamina", +5)
        ]);
    });

    this.oral = new ChangeController(id, "oral", function () {
        if (that.misc.dick()) {
            global.kobold.status.mental.increase(14, "Facefucked a basilisk");
            global.kobold.status.exertion.increase(16, "Facefucked a basilisk");

        } else {
            global.kobold.status.mental.increase(14, "Eaten out by a basilisk");
            global.kobold.status.exertion.increase(16, "Eaten out by a basilisk");
        }
    }, function () {
        if (that.misc.dick()) {
            return global.ui.change.buildNotification([
                new Change("Dominated foe", "Sanity", +12),
                new Change("Tempted fate", "Sanity", -2),
                new Change("Fucked a feral", "Sanity", -4),
                new Change("Reached climax", "Sanity", +8),
                new Change("Facefucked the basilisk", "Sexual exhaustion", +12, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true)
            ]);
        } else {
            return global.ui.change.buildNotification([
                new Change("Dominated foe", "Sanity", +12),
                new Change("Tempted fate", "Sanity", -2),
                new Change("Fucked a feral", "Sanity", -4),
                new Change("Reached climax", "Sanity", +8),
                new Change("Eaten out by the basilisk", "Sexual exhaustion", +12, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true)
            ]);
        }
    });

    this.sex = new ChangeController(id, "sex", function () {
        if (that.misc.dick()) {
            global.kobold.status.mental.increase(14, "Fucking a basilisk");
            global.kobold.status.stamina.decrease(7, "Fucking a basilisk");
            global.kobold.status.exertion.increase(24, "Fucking a basilisk");
        } else {
            global.kobold.status.mental.increase(6, "Abusing a basilisk");
            global.kobold.status.exertion.increase(5, "Abusing a basilisk");
        }
    }, function () {
        if (that.misc.dick()) {
            return global.ui.change.buildNotification([
                new Change("Dominated foe", "Sanity", +12),
                new Change("Tempted fate", "Sanity", -2),
                new Change("Fucked a feral", "Sanity", -4),
                new Change("Reached climax", "Sanity", +8),
                new Change("Intense sex", "Stamina", -7),
                new Change("Fucked the basilisk", "Sexual exhaustion", +20, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true)
            ]);
        } else {
            return global.ui.change.buildNotification([
                new Change("Dominated foe", "Sanity", +12),
                new Change("Tempted fate", "Sanity", -2),
                new Change("Fingered a feral", "Sanity", -2),
                new Change("Rimmed a feral", "Sanity", -2),
                new Change("Abused basilisk", "Sexual exhaustion", +3, true),
                new Change("Smell of cum", "Sexual exhaustion", +2, true)
            ]);
        }
    });

    this.dominanceLeave = new ChangeController(id, "dominanceLeave", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.preContinue = new ChoiceController(id, "preContinue");

    this.choices = {
        doggo: {
            PET: 1,
            FETCH: 2,
            FEED: 3
        }
    };

    this.reflectFail = new ChangeController(id, "reflectFail", function () {
        global.kobold.status.physical.decrease(2, "Cut hand");
        global.kobold.status.mental.decrease(10, "Being petrified");
        global.kobold.inventory.bag.removeMisc(ItemEnum.SMALL_MIRROR, 1);
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Cut hand", "Health", -6),
            new Change("Wound petrified", "Health", +4),
            new Change("Petrification", "Sanity", -6),
            new Change("Panic", "Sanity", -4),
            new Change("Mirror broke", global.kobold.inventory.createItemWithTooltip(new SmallMirror(), true), -1)
        ]);
    });

    this.reflectSucceed = new ChangeController(id, "reflectSucceed", function () {
        global.kobold.status.physical.decrease(6, "Cut hand");
        global.kobold.status.mental.increase(6, "Besting the basilisk");
        global.kobold.inventory.bag.removeMisc(ItemEnum.SMALL_MIRROR, 1);
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Cut hand", "Health", -6),
            new Change("Panic", "Sanity", -4),
            new Change("Heroism", "Sanity", +5),
            new Change("Bested basilisk", "Sanity", +5),
            new Change("Mirror broke", global.kobold.inventory.createItemWithTooltip(new SmallMirror(), true), -1)
        ]);
    });

    this.reflectStrike = new ChangeController(id, "reflectStrike", function () {
        global.kobold.status.mental.decrease(5, "Killing the basilisk");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Killed a vicious creature?", "Sanity", +3),
            new Change("Murdered an animal", "Sanity", -4),
            new Change("Did not accept surrender", "Sanity", -4)
        ]);
    });

    this.reflectStrikeContinue = new ChangeController(id, "reflectStrikeContinue", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
        global.kobold.inventory.bag.addMisc(new BasiliskScales());
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3),
            new Change("Trophies", global.kobold.inventory.createItemWithTooltip(new BasiliskScales(), true), +1)
        ]);
    });

    this.reflectLeave = new ChangeController(id, "reflectLeave", function () {
        global.kobold.status.mental.increase(4, "Refrained from violence");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Refrained from violence", "Sanity", +4)
        ]);
    });

    this.reflectLeaveContinue = new ChangeController(id, "reflectLeaveContinue", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.reflectPetrify = new ChangeController(id, "reflectPetrify", function () {
        global.kobold.status.mental.decrease(2, "Petrifying the basilisk");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Killed a vicious creature?", "Sanity", +3),
            new Change("Murdered an animal", "Sanity", -4),
            new Change("Did not accept surrender", "Sanity", -4),
            new Change("Delicious irony", "Sanity", +3)
        ]);
    });

    this.reflectPetrifyContinue = new ChangeController(id, "reflectPetrifyContinue", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.reflectDominance = new ChoiceController(id, "reflectDominance");

    this.reflectOral = new ChangeController(id, "reflectOral", function () {
        if (that.misc.dick()) {
            global.kobold.status.mental.increase(14, "Facefucked a basilisk");
            global.kobold.status.exertion.increase(16, "Facefucked a basilisk");

        } else {
            global.kobold.status.mental.increase(14, "Eaten out by a basilisk");
            global.kobold.status.exertion.increase(16, "Eaten out by a basilisk");
        }
    }, function () {
        if (that.misc.dick()) {
            return global.ui.change.buildNotification([
                new Change("Served by basilisk", "Sanity", +12),
                new Change("Tempted fate", "Sanity", -2),
                new Change("Fucked a feral", "Sanity", -4),
                new Change("Reached climax", "Sanity", +8),
                new Change("Facefucked the basilisk", "Sexual exhaustion", +12, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true)
            ]);
        } else {
            return global.ui.change.buildNotification([
                new Change("Served by basilisk", "Sanity", +12),
                new Change("Tempted fate", "Sanity", -2),
                new Change("Fucked a feral", "Sanity", -4),
                new Change("Reached climax", "Sanity", +8),
                new Change("Eaten out by the basilisk", "Sexual exhaustion", +12, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true)
            ]);
        }
    });

    this.reflectOralContinue = new ChangeController(id, "reflectOralContinue", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.reflectSex = new ChangeController(id, "reflectSex", function () {
        if (that.misc.dick()) {
            global.kobold.status.mental.increase(14, "Fucking a basilisk");
            global.kobold.status.stamina.decrease(7, "Fucking a basilisk");
            global.kobold.status.exertion.increase(28, "Fucking a basilisk");
        } else {
            global.kobold.status.mental.increase(4, "Fingering a basilisk");
            global.kobold.status.exertion.increase(11, "Fingering a basilisk");
        }
    }, function () {
        if (that.misc.dick()) {
            return global.ui.change.buildNotification([
                new Change("Buttfucked basilisk", "Sanity", +12),
                new Change("Tempted fate", "Sanity", -2),
                new Change("Fucked a feral", "Sanity", -2),
                new Change("Sucked a feral", "Sanity", -2),
                new Change("Reached climax", "Sanity", +8),
                new Change("Intense sex", "Stamina", -7),
                new Change("Fucked the basilisk", "Sexual exhaustion", +20, true),
                new Change("Sucked the basilisk", "Sexual exhaustion", +4, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true)
            ]);
        } else {
            return global.ui.change.buildNotification([
                new Change("Basilisk blowjob", "Sanity", +12),
                new Change("Tempted fate", "Sanity", -2),
                new Change("Fingered a feral", "Sanity", -2),
                new Change("Rimmed a feral", "Sanity", -2),
                new Change("Sucked a feral", "Sanity", -2),
                new Change("Fingered basilisk", "Sexual exhaustion", +3, true),
                new Change("Sucked basilisk", "Sexual exhaustion", +4, true),
                new Change("Smell of cum", "Sexual exhaustion", +2, true),
                new Change("Taste of cum", "Sexual exhaustion", +2, true)
            ]);
        }
    });

    this.reflectSexContinue = new ChangeController(id, "reflectSexContinue", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.reflectSub = new ChoiceController(id, "reflectSub");

    this.reflectOutside = new ChangeController(id, "reflectOutside", function () {
        var shirt = global.kobold.inventory.equipment.shirt;
        shirt && shirt.stain("Basilisk Cum");
        if (that.misc.dick()) {
            global.kobold.status.physical.decrease(4, "Riding a basilisk");
            global.kobold.status.mental.increase(20, "Riding a basilisk");
            global.kobold.status.stamina.decrease(13, "Riding a basilisk");
            global.kobold.status.exertion.increase(30, "Riding a basilisk");
        } else {
            global.kobold.status.physical.decrease(4, "Riding a basilisk");
            global.kobold.status.mental.increase(20, "Riding a basilisk");
            global.kobold.status.stamina.decrease(13, "Riding a basilisk");
            global.kobold.status.exertion.increase(30, "Riding a basilisk");
        }
    }, function () {
        if (that.misc.dick()) {
            return global.ui.change.buildNotification([
                new Change("Very sore", "Health", -4),
                new Change("Rode basilisk", "Sanity", +10),
                new Change("Fucked a feral", "Sanity", -4),
                new Change("Kissed a feral", "Sanity", -2),
                new Change("Immense climax", "Sanity", +10),
                new Change("Scaly lover", "Sanity", +6),
                new Change("Overly intense sex", "Stamina", -13),
                new Change("Rode basilisk", "Sexual exhaustion", +26, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true)
            ]);
        } else {
            return global.ui.change.buildNotification([
                new Change("Very sore", "Health", -4),
                new Change("Rode basilisk", "Sanity", +10),
                new Change("Fucked a feral", "Sanity", -4),
                new Change("Kissed a feral", "Sanity", -2),
                new Change("Intense climax", "Sanity", +8),
                new Change("Scaly lover", "Sanity", +6),
                new Change("Overly intense sex", "Stamina", -13),
                new Change("Rode basilisk", "Sexual exhaustion", +26, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true)
            ]);
        }
    });

    this.reflectInside = new ChangeController(id, "reflectInside", function () {
        var shirt = global.kobold.inventory.equipment.shirt;
        shirt && shirt.stain("Basilisk Cum");
        if (that.misc.dick()) {
            global.kobold.status.physical.decrease(4, "Riding a basilisk");
            global.kobold.status.mental.increase(20, "Riding a basilisk");
            global.kobold.status.stamina.decrease(13, "Riding a basilisk");
            global.kobold.status.exertion.increase(35, "Riding a basilisk");
        } else {
            global.kobold.status.physical.decrease(4, "Riding a basilisk");
            global.kobold.status.mental.increase(16, "Riding a basilisk");
            global.kobold.status.stamina.decrease(13, "Riding a basilisk");
            global.kobold.status.exertion.increase(35, "Riding a basilisk");
        }
    }, function () {
        if (that.misc.dick()) {
            return global.ui.change.buildNotification([
                new Change("Very sore", "Health", -4),
                new Change("Rode basilisk", "Sanity", +10),
                new Change("Fucked a feral", "Sanity", -4),
                new Change("Kissed a feral", "Sanity", -2),
                new Change("Immense climax", "Sanity", +10),
                new Change("Scaly lover", "Sanity", +6),
                new Change("Overly intense sex", "Stamina", -13),
                new Change("Rode basilisk", "Sexual exhaustion", +26, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true),
                new Change("It came inside", "Sexual exhaustion", +5, true)
            ]);
        } else {
            return global.ui.change.buildNotification([
                new Change("Very sore", "Health", -4),
                new Change("Rode basilisk", "Sanity", +10),
                new Change("Fucked a feral", "Sanity", -4),
                new Change("Kissed a feral", "Sanity", -2),
                new Change("Double climax", "Sanity", +10),
                new Change("Scaly lover", "Sanity", +6),
                new Change("Pregnant?", "Sanity", -4),
                new Change("Overly intense sex", "Stamina", -13),
                new Change("Rode basilisk", "Sexual exhaustion", +26, true),
                new Change("Reached climax", "Sexual exhaustion", +4, true),
                new Change("It came inside", "Sexual exhaustion", +5, true)
            ]);
        }
    });

    this.reflectSubContinue = new ChangeController(id, "reflectSubContinue", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.fragments = {};
    this.fragments.fight = new UndergroundCaveFight(this);
    this.fragments.surface = new UndergroundCaveSurface(this); // Needs to be separate or else can't access the fragments variable itself.

    this.bgm = new AudioController(id, "res/audio/effects/cave.mp3", 70);

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

}
