/**
 * Confrontation section of Varanar, Night Two.
 * @param {NightTwoController} controller The Night Two controller.
 */
function NightTwoLewdUnfit(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new NightTwoLewdUnfitContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var gender = ctrl.misc.baseGender();
        var genderName = GenderEnum.properties[gender].name.toLowerCase();
        var toReturn = `[p]
                            You say you are [b]flattered[/b] that the men would even [b]consider[/b] letting such an [b]ugly[/b] kobold as yourself near their loins,
                            but surely they can find a [b]prettier[/b] one than you to quell their need, right?
                            You mean, you've got some well-defined muscles, and some very visible scars.
                            Unless they [i]like[/i] that sort of stuff, that is.
                            But wouldn't that make them attracted to [b]masculine[/b] features?
                            You don't know much about humans and what they like, but that sounds kind of [i]gay[/i] to you.
                        [/p]
                        [p]
                            The group bursts into disarray.
                            "[color=purple]The lizard's right![/color]"
                            "[color=dred]Audric's a queer![/color]"
                            "[color=green]Hey now, it was [b]Jehova[/b] that pulled down his pants![/color]"
                            They begin to argue about the merits of having sex with butch-looking ${genderName} kobolds.
                            After a bit of back and forth bickering, the human in front of you pulls up his pants, and buckles his belt once more.
                            "[color=bred]Can't even get my dick sucked without a fight these days.[/color]" he mumbles.
                        [/p]
                        [p]
                            While you aren't keen on interrupting the men while they're mid-[b]discussion[/b],
                            you quietly suggest that they should perhaps go visit a whorehouse,
                            where there are plenty of more [b]feminine[/b] people eager to give them [b]all[/b] blowjobs.
                            Heck, perhaps the whores can give further insights on their little [i]disagreement[/i].
                            They [i]are[/i] experts at having sex, after all.
                            Surely they must know plenty about whether or not it's gay to face-fuck a somewhat masculine kobold.
                        [/p]
                        [p]
                            "[color=brown]Right again.
                            You're pretty smart, for a lizard![/color]"
                            One of the most attentive humans commends.
                            You quietly whisper that he has no idea just [i]how[/i] smart you are.
                            Luckily, he doesn't hear you.
                            "[color=green]Let's go settle this at the whorehouse, then![/color]"
                            "[color=purple]Yeah, let's go prove Audric's gay![/color]"
                            "[color=green]You wish, Cedric![/color]"
                            "[color=brown][b]To the brothel![/b][/color]"
                            "[color=dred]God damnit.[/color]"
                        [/p]
                        [p]
                            With that, the drunkards break their encirclement.
                            Like they've completely forgotten you even exist, they head for the brothel district, leaving you all alone in the middle of the street.
                            Just the way you like it.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = ctrl.lewdUnfit.continued() ? "disabled" : "";
        var isSelected = ctrl.lewdUnfit.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.lewdUnfit.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.appease.get() !== NightTwoLewdAppeaseChoice.UNFIT) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.lewdUnfit.change();
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.appease.get() !== NightTwoLewdAppeaseChoice.UNFIT) {
            return;
        }

        next.registerListeners();

        if (ctrl.lewdUnfit.continued()) {
            return;
        }

        registerNextListener();
    };
}
